require 'telegram/bot'

class TelegramGroupChatNotificationJob < NotificationJob
  queue_as :notifications

  def perform(**args)
    channel = NotificationChannel.find_by(name: 'telegram_group_chat')
    return unless channel.data
    return
    token = channel.data['token']
    Telegram::Bot::Client.run(token) do |bot|
      bot.api.send_message(chat_id: args[:target], text: args[:text])
    end
  end
end
