class TelegramBotSubscriber
  def self.subscribe
    ActiveSupport::Notifications.subscribe(/\A(?:session|speaker)\.updated/) do |*args|
      event = ActiveSupport::Notifications::Event.new(*args)
      new.handle_event(event)  # Call the instance method
    end
  end

  def handle_event(event)
    model_name, action = event.name.split(".")
    record = event.payload[:record]
    changes = event.payload[:changes]

    message = format_telegram_message(model_name, action, record, changes)

    # TelegramBotAPI.sendMessage(chat_id: YOUR_CHAT_ID, text: message)
    Rails.logger.info("event: #{message}")
    #TelegramGroupChatNotificationJob.perform_later(target: "-316096320", text: message)
    TelegramGroupChatNotificationJob.perform_later(target: "2192297", text: message)
  end

  private

  def format_telegram_message(model_name, action, record, changes)
    # Customize this to your desired message format
    "**#{model_name.capitalize} #{record.id} #{action}:**\n\n" +
      changes.map { |attr, (from, to)| "- #{attr}: #{from} -> #{to}" }.join("\n")
  end
end
